//
// content.cpp
//
// wanderer7 CardWirth Library Copyright (C) wanderer7 2002
//
//   L̒쌠\Ƃ̃CZXƂς
// cÃ\tgEFARɎgpEEρE
// zzč\܂B
//   L̒쌠\t̃hLgɊ܂߂A
// ̃\tgEFAgݍ񂾃\tgEFAR
// Ezzč\܂B
//   ̃\tgEFA͊Sɖۏ؂łAȂ`
// gpɂĐȂ鑹Qɂ҂͂̐ӂ
// ܂܂B
//
// ȏ
//

//
// CardWirth ́AgroupASK ̃\tgEFAłB
//   GROUP ASK WEBSITE: http://www.ask.sakura.ne.jp/
//

#include "stdafx.h"
#include "cwobj.h"
#include "content.h"
#include <algorithm>

using namespace std;
using namespace boost;
using namespace CardWirth;

Content *ContentReader::read(std::istream &in)
{
	byte type;
	in.read((char *)&type, sizeof(byte));
	in.putback(static_cast<char>(type));

	switch (type) {
	case Content::Start:
		return new Content_Start(in);
	case Content::LinkToStart:
		return new Content_LinkToStart(in);
	case Content::StartBattle:
		return new Content_StartBattle(in);
	case Content::ScenarioClear:
		return new Content_ScenarioClear(in);
	case Content::GameOver:
		return new Content_GameOver(in);
	case Content::ChangeArea:
		return new Content_ChangeArea(in);
	case Content::Message:
		return new Content_Message(in);
	case Content::ChangeBGM:
		return new Content_ChangeBGM(in);
	case Content::ChangeBG:
		return new Content_ChangeBG(in);
	case Content::PlaySE:
		return new Content_PlaySE(in);
	case Content::Wait:
		return new Content_Wait(in);
	case Content::Effect:
		return new Content_Effect(in);
	case Content::Branch_MemberChoice:
		return new Content_Branch_MemberChoice(in);
	case Content::Branch_AbilityCheck:
		return new Content_Branch_AbilityCheck(in);
	case Content::Branch_Random:
		return new Content_Branch_Random(in);
	case Content::Branch_Flag:
		return new Content_Branch_Flag(in);
	case Content::SetFlag:
		return new Content_SetFlag(in);
	case Content::MultiBranch_Step:
		return new Content_MultiBranch_Step(in);
	case Content::SetStep:
		return new Content_SetStep(in);
	case Content::Branch_Presense_Cast:
		return new Content_Branch_Presense_Cast(in);
	case Content::Branch_Posession_Item:
		return new Content_Branch_Posession_Item(in);
	case Content::Branch_Posession_Skill:
		return new Content_Branch_Posession_Skill(in);
	case Content::Branch_Posession_Info:
		return new Content_Branch_Posession_Info(in);
	case Content::Branch_Presense_Beast:
		return new Content_Branch_Presense_Beast(in);
	case Content::Branch_Money:
		return new Content_Branch_Money(in);
	case Content::Branch_Posession_Coupon:
		return new Content_Branch_Posession_Coupon(in);
	case Content::GetCast:
		return new Content_GetCast(in);
	case Content::GetItem:
		return new Content_GetItem(in);
	case Content::GetSkill:
		return new Content_GetSkill(in);
	case Content::GetInfo:
		return new Content_GetInfo(in);
	case Content::GetBeast:
		return new Content_GetBeast(in);
	case Content::GetMoney:
		return new Content_GetMoney(in);
	case Content::GetCoupon:
		return new Content_GetCoupon(in);
	case Content::LoseCast:
		return new Content_LoseCast(in);
	case Content::LoseItem:
		return new Content_LoseItem(in);
	case Content::LoseSkill:
		return new Content_LoseSkill(in);
	case Content::LoseInfo:
		return new Content_LoseInfo(in);
	case Content::LoseBeast:
		return new Content_LoseBeast(in);
	case Content::LoseMoney:
		return new Content_LoseMoney(in);
	case Content::LoseCoupon:
		return new Content_LoseCoupon(in);
	case Content::Serifu:
		return new Content_Serifu(in);
	case Content::IncStep:
		return new Content_IncStep(in);
	case Content::DecStep:
		return new Content_DecStep(in);
	case Content::InvertFlag:
		return new Content_InvertFlag(in);
	case Content::BiBranch_Step:
		return new Content_BiBranch_Step(in);
	case Content::IncRound:
		return new Content_IncRound(in);
	case Content::Branch_Level:
		return new Content_Branch_Level(in);
	case Content::Branch_Status:
		return new Content_Branch_Status(in);
	case Content::Branch_MemberCount:
		return new Content_Branch_MemberCount(in);
	case Content::ShowParty:
		return new Content_ShowParty(in);
	case Content::HideParty:
		return new Content_HideParty(in);
	case Content::BreakEffect:
		return new Content_BreakEffect(in);
	case Content::CallStart:
		return new Content_CallStart(in);
	case Content::LinkToPackage:
		return new Content_LinkToPackage(in);
	case Content::CallPackage:
		return new Content_CallPackage(in);
	case Content::Branch_Area:
		return new Content_Branch_Area(in);
	case Content::Branch_Battle:
		return new Content_Branch_Battle(in);
	case Content::Branch_ClearedScenario:
		return new Content_Branch_ClearedScenario(in);
	case Content::AddClearedScenario:
		return new Content_AddClearedScenario(in);
	case Content::RemoveClearedScenaio:
		return new Content_RemoveClearedScenaio(in);
	case Content::Branch_Gossip:
		return new Content_Branch_Gossip(in);
	case Content::AddGossip:
		return new Content_AddGossip(in);
	case Content::RemoveGossip:
		return new Content_RemoveGossip(in);
	case Content::Branch_BattleResult:
		return new Content_Branch_BattleResult(in);
	case Content::RedrawScreen:
		return new Content_RedrawScreen(in);
	case Content::FlagCheck:
		return new Content_FlagCheck(in);
	default:
		throw FileCorruptException();
	}
}

void Content::read(std::istream &in)
{
	ContentReader reader;

	type = readByte(in);
	if (type < 0 || 0x41 < type)
		throw FileCorruptException();
	label = readString(in);

	int n_childs = readDword(in) - 40000;
	if (n_childs > 65536)
		throw FileCorruptException();

	for (int i = 0; i < n_childs; i ++) {
		childs.push_back(shared_ptr<Content>(reader.read(in)));
	}
}

void Content::dump(std::ostream &out, int depth) const
{
	if (depth > 0)
		out << string(depth, '\t');
	if (label.length() > 0)
		out << label << ": ";
	dumpsingle(out);
	for (contentlist_type::const_iterator e = childs.begin(); e != childs.end(); e ++)
		(*e)->dump(out, depth+1);
}

//
// Content_Start
//
void Content_Start::read(std::istream &in)
{
	Content::read(in);
}

void Content_Start::dumpsingle(std::ostream &out) const
{
	out << "X^[gReg" << endl;
}

//
// Content_LinkToStart
//
void Content_LinkToStart::read(std::istream &in)
{
	Content::read(in);
	startName = readString(in);
}

void Content_LinkToStart::dumpsingle(std::ostream &out) const
{
	out << "X^[gւ̃N[" << startName << "]" << endl;
}

//
// Content_StartBattle
//
void Content_StartBattle::read(std::istream &in)
{
	Content::read(in);
	battleNo = readDword(in);
}

void Content_StartBattle::dumpsingle(std::ostream &out) const
{
	out << "ogJn[" << battleNo << "]" << endl;
}


//
// Content_ScenarioClear
//
void Content_ScenarioClear::read(std::istream &in)
{
	Content::read(in);
	zumiin = readBool(in);
}

void Content_ScenarioClear::dumpsingle(std::ostream &out) const
{
	out << "ViINA(ς݈" << (zumiin ? "" : "Ȃ") << ")" << endl;
}

//
// Content_GameOver
//
void Content_GameOver::read(std::istream &in)
{
	Content::read(in);
}

void Content_GameOver::dumpsingle(std::ostream &out) const
{
	out << "Q[I[o[" << endl;
}

//
// Content_ChangeArea
//
void Content_ChangeArea::read(std::istream &in)
{
	Content::read(in);
	areano = readDword(in);
}

void Content_ChangeArea::dumpsingle(std::ostream &out) const
{
	out << "GAړ[" << areano << "]" << endl;
}

//
// Content_Message
//
void Content_Message::read(std::istream &in)
{
	Content::read(in);
	imageFile = readString(in);
	message = readString(in);
}

void Content_Message::dumpsingle(std::ostream &out) const
{
	out << "bZ[W[" << message << "] (摜: " << (imageFile.length() > 0 ? imageFile : "Ȃ") << ")" << endl;
}

//
// Content_ChangeBGM
//
void Content_ChangeBGM::read(std::istream &in)
{
	Content::read(in);
	musicFileName = readString(in);
}

void Content_ChangeBGM::dumpsingle(std::ostream &out) const
{
	out << "BGMύX[" << musicFileName << "]" << endl;
}

//
// Content_ChangeBG
//
void Content_ChangeBG::read(std::istream &in)
{
	throw IOException("ChangeBG: B");
//	Content::read(in);
}

void Content_ChangeBG::dumpsingle(std::ostream &out) const
{
	out << "wiύX" << endl;
}

//
// Content_PlaySE
//
void Content_PlaySE::read(std::istream &in)
{
	Content::read(in);
	soundFileName = readString(in);
}

void Content_PlaySE::dumpsingle(std::ostream &out) const
{
	out << "ʉ[" << soundFileName << "]" << endl;
}

//
// Content_Wait
//
void Content_Wait::read(std::istream &in)
{
	Content::read(in);
	length = readDword(in);
}

void Content_Wait::dumpsingle(std::ostream &out) const
{
	out << "󔒎[" << length << "00ms]" << endl;
}

//
// Content_Effect
//
void Content_Effect::read(std::istream &in)
{
	throw IOException("Effect: B");
//	Content::read(in);
}

void Content_Effect::dumpsingle(std::ostream &out) const
{
	out << "" << endl;
}

//
// Content_Branch_MemberChoice
//
void Content_Branch_MemberChoice::read(std::istream &in)
{
	Content::read(in);
	includeBads = readBool(in);
	random = readBool(in);
}

void Content_Branch_MemberChoice::dumpsingle(std::ostream &out) const
{
	out << "oI𕪊[" 
		<< (includeBads ? "p[eBŜ" : "郁o")  
		<< (random ? "_" : "蓮")
		<< endl;
}

//
// Content_Branch_AbilityCheck
//
void Content_Branch_AbilityCheck::read(std::istream &in)
{
	Content::read(in);
	level = readDword(in);
	target = readByte(in);
	physicalRequirement = readDword(in);
	mentalRequirement = readDword(in);
}

void Content_Branch_AbilityCheck::dumpsingle(std::ostream &out) const
{
	out << "\͔蕪[...]" << endl;
}

//
// Content_BranchRandom
//
void Content_Branch_Random::read(std::istream &in)
{
	Content::read(in);
	possibility = readDword(in);
}

void Content_Branch_Random::dumpsingle(std::ostream &out) const
{
	out << "_[" << possibility << "%]" << endl;
}

//
// Content_BranchFlag
//
void Content_Branch_Flag::read(std::istream &in)
{
	Content::read(in);
	flagName = readString(in);
}

void Content_Branch_Flag::dumpsingle(std::ostream &out) const
{
	out << "tO[" << flagName << "]" << endl;
}


//
// Content_SetFlag
//
void Content_SetFlag::read(std::istream &in)
{
	Content::read(in);
	flagName = readString(in);
	value = readBool(in);
}

void Content_SetFlag::dumpsingle(std::ostream &out) const
{
	out << "tOύX[" << flagName << "=" << value << "]" << endl;
}

//
// Content_MultiBranch_Step
//
void Content_MultiBranch_Step::read(std::istream &in)
{
	Content::read(in);
	stepName = readString(in);
}

void Content_MultiBranch_Step::dumpsingle(std::ostream &out) const
{
	out << "Xebv򕪊[" << stepName << "]" << endl;
}

//
// Content_SetStep
//
void Content_SetStep::read(std::istream &in)
{
	Content::read(in);
	stepName = readString(in);
	value = readDword(in);
}

void Content_SetStep::dumpsingle(std::ostream &out) const
{
	out << "XebvύX[" << stepName << "=" << value << "]" << endl;
}

//
// Content_Branch_Presense_Cast
//
void Content_Branch_Presense_Cast::read(std::istream &in)
{
	Content::read(in);
	cardNo = readDword(in);
}

void Content_Branch_Presense_Cast::dumpsingle(std::ostream &out) const
{
	out << "LXgݕ[" << cardNo << "]" << endl;
}

//
// Content_Branch_Posession_Item
//
void Content_Branch_Posession_Item::read(std::istream &in)
{
	Content::read(in);
	cardNo = readDword(in);
	count = readDword(in);
	range = readByte(in);
}

void Content_Branch_Posession_Item::dumpsingle(std::ostream &out) const
{
	out << "ACe[" << cardNo << "Ԃ"
		<< count << ", ͈" << range << "]" << endl;
}

//
// Content_Branch_Posession_Skill
//
void Content_Branch_Posession_Skill::read(std::istream &in)
{
	Content::read(in);
	cardNo = readDword(in);
	count = readDword(in);
	range = readByte(in);
}

void Content_Branch_Posession_Skill::dumpsingle(std::ostream &out) const
{
	out << "XL[" << cardNo << "Ԃ"
		<< count << ", ͈" << range << "]" << endl;
}

//
// Content_Branch_Posession_Info
//
void Content_Branch_Posession_Info::read(std::istream &in)
{
	Content::read(in);
	cardNo = readDword(in);
}

void Content_Branch_Posession_Info::dumpsingle(std::ostream &out) const
{
	out << "񏊎[" << cardNo << "]" << endl;
}

//
// Content_Branch_Presense_Beast
//
void Content_Branch_Presense_Beast::read(std::istream &in)
{
	Content::read(in);
	cardNo = readDword(in);
	count = readDword(in);
	range = readByte(in);
}

void Content_Branch_Presense_Beast::dumpsingle(std::ostream &out) const
{
	out << "bݕ[" << cardNo << "Ԃ"
		<< count << ", ͈" << range << "]" << endl;
}

//
// Content_Branch_Money
//
void Content_Branch_Money::read(std::istream &in)
{
	Content::read(in);
	value = readDword(in);
}

void Content_Branch_Money::dumpsingle(std::ostream &out) const
{
	out << "[" << value << "sp]" << endl;
}

//
// Content_Branch_Posession_Coupon
//
void Content_Branch_Posession_Coupon::read(std::istream &in)
{
	Content::read(in);
	couponName = readString(in);
	unknown = readDword(in);
	range = readByte(in);
}

void Content_Branch_Posession_Coupon::dumpsingle(std::ostream &out) const
{
	out << "̍[y" << couponName << "z, "
		<< "͈" << range << ", (unknown=" << unknown << ")]" << endl;
}

//
// Content_GetCast
//
void Content_GetCast::read(std::istream &in)
{
	Content::read(in);
	cardNo = readDword(in);
}

void Content_GetCast::dumpsingle(std::ostream &out) const
{
	out << "LXg[" << cardNo << "]" << endl;
}

//
// Content_GetItem
//
void Content_GetItem::read(std::istream &in)
{
	Content::read(in);
	cardNo = readDword(in);
	count = readDword(in);
	range = readByte(in);
}

void Content_GetItem::dumpsingle(std::ostream &out) const
{
	out << "ACe[" << cardNo << "Ԃ"
		<< count << ", ͈" << range << "]" << endl;
}

//
// Content_GetSkill
//
void Content_GetSkill::read(std::istream &in)
{
	Content::read(in);
	cardNo = readDword(in);
	count = readDword(in);
	range = readByte(in);
}

void Content_GetSkill::dumpsingle(std::ostream &out) const
{
	out << "XL[" << cardNo << "Ԃ"
		<< count << ", ͈" << range << "]" << endl;
}

//
// Content_GetInfo
//
void Content_GetInfo::read(std::istream &in)
{
	Content::read(in);
	cardNo = readDword(in);
}

void Content_GetInfo::dumpsingle(std::ostream &out) const
{
	out << "[" << cardNo << "]" << endl;
}

//
// Content_GetBeast
//
void Content_GetBeast::read(std::istream &in)
{
	Content::read(in);
	cardNo = readDword(in);
	count = readDword(in);
	range = readByte(in);
}

void Content_GetBeast::dumpsingle(std::ostream &out) const
{
	out << "b[" << cardNo << "Ԃ"
		<< count << ", ͈" << range << "]" << endl;
}

//
// Content_GetMoney
//
void Content_GetMoney::read(std::istream &in)
{
	Content::read(in);
	value = readDword(in);
}

void Content_GetMoney::dumpsingle(std::ostream &out) const
{
	out << "[" << value << "sp]" << endl;
}

//
// Content_GetCoupon
//
void Content_GetCoupon::read(std::istream &in)
{
	Content::read(in);
	couponName = readString(in);
}

void Content_GetCoupon::dumpsingle(std::ostream &out) const
{
	out << "̍l[y" << couponName << "z(" << point
		<< "), ͈" << range << "]" << endl;
}

//
// Content_LoseCast
//
void Content_LoseCast::read(std::istream &in)
{
	Content::read(in);
	cardNo = readDword(in);
}

void Content_LoseCast::dumpsingle(std::ostream &out) const
{
	out << "LXgE[" << cardNo << "]" << endl;
}

//
// Content_LoseItem
//
void Content_LoseItem::read(std::istream &in)
{
	Content::read(in);
	cardNo = readDword(in);
	count = readDword(in);
	range = readByte(in);
}

void Content_LoseItem::dumpsingle(std::ostream &out) const
{
	out << "ACer[" << cardNo << "Ԃ"
		<< count << ", ͈" << range << "]" << endl;
}

//
// Content_LoseSkill
//
void Content_LoseSkill::read(std::istream &in)
{
	Content::read(in);
	cardNo = readDword(in);
	count = readDword(in);
	range = readByte(in);
}

void Content_LoseSkill::dumpsingle(std::ostream &out) const
{
	out << "XLr[" << cardNo << "Ԃ"
		<< count << ", ͈" << range << "]" << endl;
}

//
// Content_LoseInfo
//
void Content_LoseInfo::read(std::istream &in)
{
	Content::read(in);
	cardNo = readDword(in);
}

void Content_LoseInfo::dumpsingle(std::ostream &out) const
{
	out << "r[" << cardNo << "]" << endl;
}

//
// Content_LoseBeast
//
void Content_LoseBeast::read(std::istream &in)
{
	Content::read(in);
	cardNo = readDword(in);
	count = readDword(in);
	range = readByte(in);
}

void Content_LoseBeast::dumpsingle(std::ostream &out) const
{
	out << "br[" << cardNo << "Ԃ"
		<< count << ", ͈" << range << "]" << endl;
}

//
// Content_LoseMoney
//
void Content_LoseMoney::read(std::istream &in)
{
	Content::read(in);
	value = readDword(in);
}

void Content_LoseMoney::dumpsingle(std::ostream &out) const
{
	out << "[" << value << "sp]" << endl;
}

//
// Content_LoseCoupon
//
void Content_LoseCoupon::read(std::istream &in)
{
	Content::read(in);
	couponName = readString(in);
	range = readByte(in);
}

void Content_LoseCoupon::dumpsingle(std::ostream &out) const
{
	out << "̍D[y" << couponName << "z"
		<< ", ͈" << range << "]" << endl;
}

//
// Content_Serifu
//
void Content_Serifu::read(std::istream &in)
{	
	throw IOException("Serifu: B");
//	Content::read(in);
}

void Content_Serifu::dumpsingle(std::ostream &out) const
{
	out << "Zt" << endl;
}

//
// Content_IncStep
//
void Content_IncStep::read(std::istream &in)
{
	Content::read(in);
	stepName = readString(in);
}

void Content_IncStep::dumpsingle(std::ostream &out) const
{
	out << "Xebv[" << stepName << "]" << endl;
}

//
// Content_DecStep
//
void Content_DecStep::read(std::istream &in)
{
	Content::read(in);
	stepName = readString(in);
}

void Content_DecStep::dumpsingle(std::ostream &out) const
{
	out << "Xebv[" << stepName << "]" << endl;
}

//
// Content_InvertFlag
//
void Content_InvertFlag::read(std::istream &in)
{
	Content::read(in);
	flagName = readString(in);
}

void Content_InvertFlag::dumpsingle(std::ostream &out) const
{
	out << "tO][" << flagName << "]" << endl;
}

//
// Content_BiBranch_Step
//
void Content_BiBranch_Step::read(std::istream &in)
{
	Content::read(in);
	stepName = readString(in);
	value = readDword(in);
}

void Content_BiBranch_Step::dumpsingle(std::ostream &out) const
{
	out << "Xebv򕪊[" << stepName << ", E" << value << "]" << endl;
}

//
// Content_IncRound
//
void Content_IncRound::read(std::istream &in)
{
	Content::read(in);
}

void Content_IncRound::dumpsingle(std::ostream &out) const
{
	out << "Ԍo" << endl;
}

//
// Content_Branch_Level
//
void Content_Branch_Level::read(std::istream &in)
{
	Content::read(in);
	isAverage = readBool(in);
	value = readDword(in);
}

void Content_Branch_Level::dumpsingle(std::ostream &out) const
{
	out << "x[" << (isAverage ? "" : "I") << "" << value << "]" << endl;
}

//
// Content_Branch_Status
//
void Content_Branch_Status::read(std::istream &in)
{
	Content::read(in);
	status = readByte(in);
	target = readByte(in);
}

void Content_Branch_Status::dumpsingle(std::ostream &out) const
{
	out << "ԕ[" << status << ", Kpo" << target << "]" << endl;
}

//
// Content_Branch_MemberCount
//
void Content_Branch_MemberCount::read(std::istream &in)
{
	Content::read(in);
	count = readDword(in);
}

void Content_Branch_MemberCount::dumpsingle(std::ostream &out) const
{
	out << "l蕪[" << count << "l]" << endl;
}

//
// Content_ShowParty
//
void Content_ShowParty::read(std::istream &in)
{
	Content::read(in);
}

void Content_ShowParty::dumpsingle(std::ostream &out) const
{
	out << "p[eB\" << endl;
}

//
// Content_HideParty
//
void Content_HideParty::read(std::istream &in)
{
	Content::read(in);
}

void Content_HideParty::dumpsingle(std::ostream &out) const
{
	out << "p[eBB" << endl;
}

//
// Content_BreakEffect
//
void Content_BreakEffect::read(std::istream &in)
{
	Content::read(in);
}

void Content_BreakEffect::dumpsingle(std::ostream &out) const
{
	out << "ʒf" << endl;
}

//
// Content_CallStart
//
void Content_CallStart::read(std::istream &in)
{
	Content::read(in);
	startName = readString(in);
}

void Content_CallStart::dumpsingle(std::ostream &out) const
{
	out << "X^[g̃R[[" << startName << "]"<< endl;
}

//
// Content_LinkToPackage
//
void Content_LinkToPackage::read(std::istream &in)
{
	Content::read(in);
	packageNo = readDword(in);
}

void Content_LinkToPackage::dumpsingle(std::ostream &out) const
{
	out << "pbP[Wւ̃N[" << packageNo << "]" << endl;
}

//
// Content_CallPackage
//
void Content_CallPackage::read(std::istream &in)
{
	Content::read(in);
	packageNo = readDword(in);
}

void Content_CallPackage::dumpsingle(std::ostream &out) const
{
	out << "pbP[W̃R[[" << packageNo << "]" << endl;
}

//
// Content_Branch_Area
//
void Content_Branch_Area::read(std::istream &in)
{
	Content::read(in);
}

void Content_Branch_Area::dumpsingle(std::ostream &out) const
{
	out << "GA" << endl;
}

//
// Content_Branch_Battle
//
void Content_Branch_Battle::read(std::istream &in)
{
	Content::read(in);
}

void Content_Branch_Battle::dumpsingle(std::ostream &out) const
{
	out << "og" << endl;
}

//
// Content_Branch_ClearedScenario
//
void Content_Branch_ClearedScenario::read(std::istream &in)
{
	Content::read(in);
	scenarioName = readString(in);
}

void Content_Branch_ClearedScenario::dumpsingle(std::ostream &out) const
{
	out << "IViI[" << scenarioName << "]" << endl;
}

//
// Content_AddClearedScenario
//
void Content_AddClearedScenario::read(std::istream &in)
{
	Content::read(in);
	scenarioName = readString(in);
}

void Content_AddClearedScenario::dumpsingle(std::ostream &out) const
{
	out << "IViIݒ[" << scenarioName << "]" << endl;
}

//
// Content_RemoveClearedScenaio
//
void Content_RemoveClearedScenaio::read(std::istream &in)
{
	Content::read(in);
	scenarioName = readString(in);
}

void Content_RemoveClearedScenaio::dumpsingle(std::ostream &out) const
{
	out << "IViI폜[" << scenarioName << "]" << endl;
}

//
// Content_Branch_Gossip
//
void Content_Branch_Gossip::read(std::istream &in)
{
	Content::read(in);
	gossipName = readString(in);
}

void Content_Branch_Gossip::dumpsingle(std::ostream &out) const
{
	out << "SVbv[" << gossipName << "]" << endl;
}

//
// Content_AddGossip
//
void Content_AddGossip::read(std::istream &in)
{
	Content::read(in);
	gossipName = readString(in);
}

void Content_AddGossip::dumpsingle(std::ostream &out) const
{
	out << "SVbvǉ[" << gossipName << "]" << endl;
}

//
// Content_RemoveGossip
//
void Content_RemoveGossip::read(std::istream &in)
{
	Content::read(in);
	gossipName = readString(in);
}

void Content_RemoveGossip::dumpsingle(std::ostream &out) const
{
	out << "SVbv폜[" << gossipName << "]" << endl;
}

//
// Content_Branch_BattleResult
//
void Content_Branch_BattleResult::read(std::istream &in)
{
	Content::read(in);
}

void Content_Branch_BattleResult::dumpsingle(std::ostream &out) const
{
	out << "og蕪" << endl;
}

//
// Content_RedrawScreen
//
void Content_RedrawScreen::read(std::istream &in)
{
	Content::read(in);
}

void Content_RedrawScreen::dumpsingle(std::ostream &out) const
{
	out << "ʂ̍č\z" << endl;
}

//
// Content_FlagCheck
//
void Content_FlagCheck::read(std::istream &in)
{
	Content::read(in);
	flagName = readString(in);
}

void Content_FlagCheck::dumpsingle(std::ostream &out) const
{
	out << "tO[" << flagName << "]" << endl;
}
