#ifndef CARDWIRTH_CWOBJ_H_INCLUDED
#define CARDWIRTH_CWOBJ_H_INCLUDED


//
// cwobj.h
//
// wanderer7 CardWirth Library Copyright (C) wanderer7 2002
//
//   L̒쌠\Ƃ̃CZXƂς
// cÃ\tgEFARɎgpEEρE
// zzč\܂B
//   L̒쌠\t̃hLgɊ܂߂A
// ̃\tgEFAgݍ񂾃\tgEFAR
// Ezzč\܂B
//   ̃\tgEFA͊Sɖۏ؂łAȂ`
// gpɂĐȂ鑹Qɂ҂͂̐ӂ
// ܂܂B
//
// ȏ
//

//
// CardWirth ́AgroupASK ̃\tgEFAłB
//   GROUP ASK WEBSITE: http://www.ask.sakura.ne.jp/
//

#include <string>
#include <stdexcept>

namespace CardWirth
{
	class IOException : public std::runtime_error
	{
	public:
		explicit IOException(const std::string& s = "I/OO")
			: runtime_error(s) {};
		virtual ~IOException() {};
	};

	class OpenFailedException : public IOException
	{
	public:
		explicit OpenFailedException(const std::string& s = "J܂")
			: IOException(s) {};
		virtual ~OpenFailedException() {};
	};

	class FileNotFoundException : public IOException
	{
	public:
		explicit FileNotFoundException(const std::string& s = "t@C܂")
			: IOException(s) {};
		virtual ~FileNotFoundException() {};
	};

	class FileCorruptException : public IOException
	{
	public:
		explicit FileCorruptException(const std::string& s = "t@CĂ܂")
			: IOException(s) {};
		virtual ~FileCorruptException() {};
	};


	class CWObject
	{
	public:
		CWObject() {};
		virtual ~CWObject() {};
		virtual void dump(std::ostream &out) const throw(std::runtime_error) = 0;
		std::string getDumpString() const throw(std::runtime_error) { std::ostringstream s; dump(s); return s.str(); };
	protected:
		static std::string readString(std::istream &in) throw (IOException);
		static bool readBool(std::istream &in) throw (IOException);
		static byte readByte(std::istream &in) throw (IOException);
		static word readWord(std::istream &in) throw (IOException);
		static dword readDword(std::istream &in) throw (IOException);
	};
}

#endif // CARDWIRTH_CWOBJ_H_INCLUDED
