//
// motion.cpp
//
// wanderer7 CardWirth Library Copyright (C) wanderer7 2002
//
//   L̒쌠\Ƃ̃CZXƂς
// cÃ\tgEFARɎgpEEρE
// zzč\܂B
//   L̒쌠\t̃hLgɊ܂߂A
// ̃\tgEFAgݍ񂾃\tgEFAR
// Ezzč\܂B
//   ̃\tgEFA͊Sɖۏ؂łAȂ`
// gpɂĐȂ鑹Qɂ҂͂̐ӂ
// ܂܂B
//
// ȏ
//

//
// CardWirth ́AgroupASK ̃\tgEFAłB
//   GROUP ASK WEBSITE: http://www.ask.sakura.ne.jp/
//

#include "stdafx.h"
#include "cwcard.h"

using namespace std;
using namespace CardWirth;

const char *Motion::attrNameStr[]
	= {"S", "", "_", "_", "@", "", "C"};

Motion::Motion()
{
	init();
}

void Motion::init()
{
	type1 = type2 = 0;
	attr = 0;
	valueType = value = round = 0;
}


void Motion::read(std::istream &in)
{
	type1 = readByte(in);	// 啪
	readByte(in);
	readDword(in);	// 悭ܶ݃f[^̓ǂݎ̂
	attr = readByte(in);	// 
	type2 = readByte(in);	// 

	switch(type1) {
	case 0:	// 
	case 1:	// 
		valueType = readByte(in);
		value = readDword(in);
		if (valueType < 0 || 2 < valueType)
			throw FileCorruptException();
		break;
	case 3:	// _
	case 4:	// @
		round = readDword(in);
		if (round < 0)
			throw FileCorruptException();
		break;
	case 5:	// \
		value = readDword(in);
		round = readDword(in);
		if (round < 0)
			throw FileCorruptException();
		break;
	case 2:	// Z\
	case 6:	// 
	case 7:	// zz
		break;
	case 8:	// 
		throw runtime_error("ɂ͑ΉĂ܂B");
	default:
		throw FileCorruptException();
	}
}

void Motion::dump(std::ostream &out) const
{
#define NONE 0
#define SELECTED 1
#define ROUND 2
#define DIRECT_AND_ROUND 3
	struct {
		int argType;
		char *name;
	} const static motionInfo[9][8] = {
		{{SELECTED, "͉"}, {SELECTED, "̓_[W"}, {SELECTED, "͋z"}},
		{{SELECTED, "჏"}, {SELECTED, "჉"}, {SELECTED, "ŏ"}, {SELECTED, "ŉ"}},
		{{NONE, "_͉"}, {NONE, "_͕s\"}},
		{{ROUND, ""}, {ROUND, ""}, {ROUND, "V"}, {ROUND, "E"}, {ROUND, "Q"}, {NONE, ""}},
		{{ROUND, ""}, {NONE, ""}, {ROUND, "ُ"}, {NONE, "ى"}, {ROUND, "\I"}, {NONE, "\I"}, {ROUND, "@"}, {NONE, "@"}},
		{{DIRECT_AND_ROUND, "s͕ω"}, {DIRECT_AND_ROUND, "͕ω"}, {DIRECT_AND_ROUND, "R͕ω"}, {DIRECT_AND_ROUND, "h͕ω"}},
		{{NONE, "Ώۏi񐄏j"}, {NONE, "J[h"}, {NONE, "b"}},
		{{NONE, "ʏUzz"}, {NONE, "Ӑg̈ꌂzz"}, {NONE, "Szz"}, {NONE, "tFCgzz"}, {NONE, "hzz"}, {NONE, "؂zz"}, {NONE, "zz"}, {NONE, "Z\zz"}},
		{{NONE, "b"}}
	};

	out << motionInfo[type1][type2].name << "(" << getAttrName() << ")";
	switch (motionInfo[type1][type2].argType) {
	case SELECTED:
		switch (valueType) {
		case 0:	out << ": Lv" << value; break;
		case 1:	out << ": " << value; break;
		case 2:	out << ": ől"; break;
		}
		break;
	case ROUND:
		out << ": " << round << "Eh";
		break;
	case DIRECT_AND_ROUND:
		out << ": " << value << ", " << round << "Eh";
		break;
	case NONE:
	default:
		break;
	}
}
#undef NONE
#undef ROUND
#undef DIRECT_AND_ROUND
#undef SELECTED

std::string Motion::getAttrName() const
{
	return string(attrNameStr[attr]);
}

std::string Motion::getAttrName(int attr)
{
	if (attr < 0 || 6 < attr)
		throw range_error("Motion::getAttrName(): argument out of range");
	return string(attrNameStr[attr]);
}
