//
// skillcard.cpp
//
// wanderer7 CardWirth Library Copyright (C) wanderer7 2002
//
//   L̒쌠\Ƃ̃CZXƂς
// cÃ\tgEFARɎgpEEρE
// zzč\܂B
//   L̒쌠\t̃hLgɊ܂߂A
// ̃\tgEFAgݍ񂾃\tgEFAR
// Ezzč\܂B
//   ̃\tgEFA͊Sɖۏ؂łAȂ`
// gpɂĐȂ鑹Qɂ҂͂̐ӂ
// ܂܂B
//
// ȏ
//

//
// CardWirth ́AgroupASK ̃\tgEFAłB
//   GROUP ASK WEBSITE: http://www.ask.sakura.ne.jp/
//

#include "stdafx.h"
#include "cwcard.h"

using namespace std;
using namespace CardWirth;

static const char *notSkillFile = "Z\J[hł͂܂";

const char *SkillCard::targetTypeStr[]
	= {"Ώۖ", "gp", "", "G", "o"};
const char *SkillCard::effectTypeStr[]
	= {"", "@", "@I", "I@"};
const char *SkillCard::valueTypeStr[]
	= {"Lv", "", "ől"};
const char *SkillCard::mreqstr[]
	= {"", "_", "a", "C", "a", "????", "D", "zC", "E", "Td", ""};
const char **SkillCard::mentalRequirementStr
	= &SkillCard::mreqstr[5];
const char *SkillCard::physicalRequirementStr[]
	=  {"px", "m", "q", "ؗ", "", "_"};

SkillCard::SkillCard()
{
	init();
}

void SkillCard::init()
{
	int i;

	name = description = scenario = author = "";
	for (i = 0; i < sizeof(soundEffects)/sizeof(soundEffects[0]); i ++)
		soundEffects[i] = "";
	for (i = 0; i < sizeof(keycodes)/sizeof(keycodes[0]); i ++)
		keycodes[i] = "";
		
	physicalRequirement = mentalRequirement = 0;
	targetType = effectType = 0;
	verbal = targetsGrp = magical = false;
	toSuccess = 0;
	visualEffect = 0;
	level = rarity = 0;
	bonus[0] = bonus[1] = bonus[2] = 0;
	motions.erase(motions.begin(), motions.end());
}

void SkillCard::readFile(const char *filename)
{
	ifstream in (filename, ios::binary | ios::in);
	dword dw;
	int	i,n;

	// ǂ݂
	if (in.fail()) {
		throw OpenFailedException();
	}

	init();

	if (readByte(in) != 5) {
		throw FileCorruptException(notSkillFile);
	}

	// 摜
	dw = readDword(in);
	if (dw != 0) {
		if (readWord(in) != ('B' | 'M' << 8)) {
			throw FileCorruptException(notSkillFile);
		}
		in.seekg(dw-2, ios::cur);
	}


	name = readString(in);
	readDword(in);	// sBǂݎ̂Ă
	description = readString(in);
	physicalRequirement = readDword(in);
	mentalRequirement = readDword(in);
	verbal = readBool(in);
	targetsGrp = readBool(in);
	targetType = readByte(in);
	effectType = readByte(in);
	magical = readBool(in);
	toSuccess = readDword(in);
	visualEffect = readByte(in);

	// 
	n = readDword(in);	// ʐ
	for (i = 0; i < n; i ++) {
		Motion m;

		m.read(in);
		motions.push_back(m);
	}

	for (i = 0; i < 3; i ++)
		bonus[i] = readDword(in);
	for (i = 0; i < 2; i ++)
		soundEffects[i] = readString(in);
	for (i = 0; i < 5; i ++)
		keycodes[i] = readString(in);
	rarity = readByte(in);
	scenario = readString(in);
	author = readString(in);

	eventPart.read(in);

	readByte(in);		// sȃf[^
//	in.seekg(-8, ios::end);
	level = readDword(in);

	if (physicalRequirement < 0 || 5 < physicalRequirement ||
		mentalRequirement < -5 || 5 < mentalRequirement ||
		targetType < 0 || 4 < targetType ||
		effectType < 0 || 3 < effectType ||
		toSuccess < -10 || 10 < toSuccess ||
		rarity < 0 || 2 < rarity ||
		level < 0 ) {
		init();
		throw FileCorruptException();
	}
}

void SkillCard::dump(std::ostream &out) const
{
	int i;
	list<Motion>::const_iterator e;

//	out << "ViI: " << scenario << endl;
//	out << ": " << author << endl;
	out << ": " << name << endl;
	out << "Z\Lv: " <<  level << endl;
//	out << ": " << description << endl;
	out << "ڕW: " << targetTypeStr[targetType] << ((targetType == 0) ? "" : (targetsGrp ? "S" : "P")) << endl;
	out << "ʑ: " << effectTypeStr[effectType] << endl;
	out << "َgp: " << (verbal ? "s" : "") << endl;
	out << "R: " << (magical ? "R" : "") << endl;
	out << "Cl: " << toSuccess << endl;
	out << "gp{[iX(, R, h): " << bonus[0] << ", " << bonus[1] << ", " << bonus[2] << endl;
	out << "g̓Ivf: " << physicalRequirementStr[physicalRequirement] << endl;
	out << "_Ivf: " << mentalRequirementStr[mentalRequirement] << endl;
//	out << "󏭓x: " << rarity << endl;
//	out << "o: " <<  visualEffect << endl;
//	out << "ʉ: " << soundEffects[0] << ", " << soundEffects[1] << endl;
	out << "L[R[h: ";
	for (i = 0;i < 5; i ++) {
		out << keycodes[i];
		if (i != 4)
			out << ", ";
		else
			out << endl;
	}

	for (e = motions.begin(); e != motions.end(); ++e) {
		e->dump(out);
		out << endl;
	}

	eventPart.dump(out);
}

std::string SkillCard::getTargetTypeName() const
{
	return string(targetTypeStr[targetType]);
}

std::string SkillCard::getTargetTypeName(int targetType)
{
	if (targetType < 0 || 4 < targetType)
		throw range_error("SkillCard::getTargetTypeName(): argument out of range");
	return string(targetTypeStr[targetType]);
}

int SkillCard::getBonus(int n) const
{
	if (n < 0 || 2 < n)
		throw std::range_error("SkillCard::getBonus(): argument out of range");
	return bonus[n];
}



