#ifndef CARDWIRTH_SKILLCARD_H_INCLUDED
#define CARDWIRTH_SKILLCARD_H_INCLUDED

//
// skillcard.h
//
// wanderer7 CardWirth Library Copyright (C) wanderer7 2002
//
//   L̒쌠\Ƃ̃CZXƂς
// cÃ\tgEFARɎgpEEρE
// zzč\܂B
//   L̒쌠\t̃hLgɊ܂߂A
// ̃\tgEFAgݍ񂾃\tgEFAR
// Ezzč\܂B
//   ̃\tgEFA͊Sɖۏ؂łAȂ`
// gpɂĐȂ鑹Qɂ҂͂̐ӂ
// ܂܂B
//
// ȏ
//

//
// CardWirth ́AgroupASK ̃\tgEFAłB
//   GROUP ASK WEBSITE: http://www.ask.sakura.ne.jp/
//

#include <string>
#include <list>
#include "cwcard.h"
#include "event.h"

namespace CardWirth
{
	class SkillCard : public CWCard
	{
	public:
		SkillCard();
		virtual ~SkillCard() {};
		virtual void init();
		void readFile(const char *filename) throw(std::runtime_error);
		virtual void dump(std::ostream &out) const throw(std::runtime_error);
		std::string getDumpString() const;

		std::string getTargetTypeName() const;
		static std::string getTargetTypeName(int ttype) throw(std::runtime_error);
	// bool isParriable?
		bool isMagical() const { return magical; };
		bool isVerbal() const { return verbal; };
		bool targetsGroup() const { return targetsGrp; };
		int getTargetType() const { return targetType; };
		int getEffectType() const { return effectType; };
		int getLevel() const { return level; };
		int getToSuccess() const { return toSuccess; };
		int getBonus(int n) const throw(std::runtime_error);
		const std::list<Motion> *getMotions() const { return &motions; };

	protected:
		static const char *targetTypeStr[];
		static const char *effectTypeStr[];
		static const char *valueTypeStr[];
		static const char **mentalRequirementStr;
		static const char *physicalRequirementStr[];
	//	std::string name;	// 
		std::string description;	// 
		std::string scenario;
		std::string author;
		std::string soundEffects[2];
		std::string keycodes[5];
		bool	verbal;	// َgps
		bool	targetsGrp;	// ڕW: S
		bool	magical;	// R: R
		int	physicalRequirement;	// g̓Ivf
		int	mentalRequirement;	// _Ivf
		int	targetType;	// ʖڕW
		int	effectType;	// ʑ
		int	rarity;
		int	level;
		int	toSuccess;	// C
		int	visualEffect;	// o
		int	bonus[3];
		EventPart eventPart;
		std::list<Motion> motions;
	private:
		static const char *mreqstr[];
	};
}

#endif // CARDWIRTH_SKILLCARD_H_INCLUDED
